unit USegRegUtils;

interface

uses Dialogs, UDMSegReg;


const                         {tbv graphics}

  PosX1=70;
  PosX2=PosX1+500;
  PosY1=80;
  PosY2=PosY1+320;

  MaxLength = 28;              {tbv pathname under DOS}

var
    {Input}
  CalcMethod, ShortDir,
  AuxDir                 : string;
  CalcDone               : boolean;
    {Graphics}
    {Arrange and Parameters}
  AAs,Ag,Bs,Bg,BP1,BP2,Aux1,Aux2,Aux3,Aux4,Aux5,AvX,AvY : real;
  AvY1,AvY2,AvYr1,AvYr2,AvX1,AvX2,AvXr1,AvXr2,Corr      : real;
  AvXall,StdAall,StdYRall,BP,StdY1,StdY2,SDbp,SDbpR     : real;
  AvXall1,AvXall2,StdAall1,StdAall2,StdYRall1,StdYRall2 : real;
  RedSumXsq1, RedSumXSq2,Nr1R,Nr2R,AvXallR              : real;
  A1,A2,Nr1,Nr2,StdA1,StdA2,StdB1,StdB2,StdYr1,StdYr2   : real;
  StDevY1,StDevY2,StDevY1R,StDevY2R : real;
  StDevX, StDevXR,
  YatBP, YatBPR                : real;
  ExplCoeff, ExplCoeffR        : real;
  ExplCoeffT                   : real;
  X1,X2,X3,X4,X5,X6,X7,X8      : real;
  X9,X10,X11,X12,X13,X13A,X14  : real;
  X15,X15A,X16,X17,X18         : real;
  Y1,Y2,Y3,Y4,Y5,Y6,Y7,Y8      : real;
  Y9,Y10,Y11,Y12,Y13,Y13A,Y14  : real;
  Y15,Y15A,Y16,PlotY1,PlotY2   : real;
  GraphType, RegrType,
  RegrType1, RegrType2, Type6,
  GraphIndex, RegrMeth,
  RegrMeth1, RegrMeth2,
  PrevRegrType                 : byte;
    {MaxMin}
  Ymax, Ymin, Xmax, Xmin       : real;
  MaxY, MinY, MaxX, MinX       : longint;
  FactorY, FactorX,
  ScaleY, ScaleX, LX, LY,
  DecimY, DecimX               : integer;
  RelXdata, RelYdata, RelZdata : array of integer;
  DumData                      : array of real;
  LegendX, LegendY             : string;
  InverseX, InverseY, NoBelt   : boolean;

    {Graphics}
  procedure SelectData;
  procedure MaxMin;
  procedure Relative;
  procedure Legends;
  procedure Parameters1;
  procedure Parameters2;
  procedure Parameters3;
  procedure SwapVar;


implementation

{ ------------------------------------------------------------------
    Graphics
 -------------------------------------------------------------------}

{SelectData is part of TSegRegForm.GraphSaveActionExecute,
 TSegRegForm.SaveBlWhButtonClick, TSegRegForm.CalcObs_ButtonClick
 and TSegRegForm.GoButtonClick}
procedure SelectData;
var ii : integer;
begin
  GraphIndex:=0;
  with DMSegReg do
  begin
    if GraphType<2 then                      {regr. on the first variable}
    begin
            RegrType:=RegrType1;
            RegrMeth:=RegrMeth1;
            if Code=' Y-X' then
            begin
//GraphIndex serves to define legends and presentation of graphs}
              GraphIndex := 10;
              if RegrType<2 then GraphIndex:=11;
              if RegrType<2 then AAs:=Ag;
            end;
            if Code=' Y-Z' then
            begin
              GraphIndex := 12;
              if RegrType<2 then GraphIndex:=13;
              if RegrType<2 then AAs:=Ag;
              for ii:=0 to NrOfData-1 do
              begin
                Aux1 := Xdata[ii];
                Xdata[ii] := Zdata[ii];
                Zdata[ii] := Aux1;
              end;
            end;
    end; {if GraphType=1}

    if GraphType=2 then                   {regr. of residuals on 2nd variable}
    begin
            RegrType:=RegrType2;
            RegrMeth:=RegrMeth2;
            if Code=' Y-X' then
            begin
              if RegrType<2 then AAs:=Bg;
              GraphIndex := 14;
              if RegrType<2 then GraphIndex:=15;
              for ii:=0 to NrOfData-1 do
              begin
                Aux1 := Xdata[ii];
                Xdata[ii] := Zdata[ii];
                Zdata[ii] := Aux1;
                Aux2 := Ydata[ii];
                Ydata[ii] := Yrdata[ii];
                Yrdata[ii] := Aux2;
              end;
            end;
            if Code=' Y-Z' then
            begin
              if RegrType<2 then AAs:=Bg;
              GraphIndex := 16;
              if RegrType<2 then GraphIndex:=17;
              for ii:=0 to NrOfData-1 do
              begin
                Aux2 := Ydata[ii];
                Ydata[ii] := Yrdata[ii];
                Yrdata[ii] := Aux2;
              end;
            end;
            if Code<>' Fun' then SwapVar;
    end;                          {end of condition GraphType=2}

    if GraphType=3 then               {Plots Yobs on Y versus Ycalc on X}
    begin
            GraphIndex := 18;
//GraphIndex 18 produces a graph without confidence belts
            RegrType := 1;
            for ii:=0 to NrOfData-1 do
                Xdata[ii]  := Ycdata[ii];
    end; {if GraphType=3}

    if GraphType=4 then                  {Plot of X,Z data}
    begin
            if Code=' Y-X' then
            begin
               GraphIndex := 19;
//GraphIndex>=19 serves for graphs without regression
               for ii:=0 to NrOfData-1 do
               begin
                 Aux1 := Zdata[ii];
                 Zdata[ii] := Xdata[ii];
                 Xdata[ii] := Aux1;
               end;
            end;
            if Code=' Y-Z' then GraphIndex := 20;
            RegrType := 1;
    end; {if GraphType=4}

    if GraphType=5 then                  {plot of Y data versus 2nd variable}
    begin
            if Code=' Y-X' then
            begin
               GraphIndex := 21;
               for ii:=0 to NrOfData-1 do
               begin
                 Aux1 := Ydata[ii];
                 Ydata[ii] := Xdata[ii];
                 setlength (DumData,ii+1);
                 DumData[ii] := Aux1;
                 Aux2 := Yrdata[ii];
                 Xdata[ii] := Zdata[ii];
                 Zdata[ii] := Aux2;
               end;
            end;
            if Code=' Y-Z' then
            begin
               GraphIndex := 22;
               for ii:=0 to NrOfData-1 do
               begin
                 Aux1 := Ydata[ii];
                 Ydata[ii] := Zdata[ii];
                 Zdata[ii] := Aux1;
               end;
            end;
            RegrType := 1;
    end; {if GraphType=5}
  end; {end of with DMSegReg do}
end;
{end of SelectData}
{-----------------}



{MaxMin is part of TSegRegForm.Showgraphics1 & 2}
{-----------------------------------------------}
procedure MaxMin;

var ii : integer;

begin
  Ymax  := -1000000;
  Xmax  := -1000000;
  Ymin  := 10000000;
  Xmin  := 10000000;

  for ii:=0 to DMSegReg.NrOfData-1 do with DMSegReg do
  begin
    if DMSegReg.Ydata[ii]>Ymax then Ymax := DMSegReg.Ydata[ii];
    if DMSegReg.Xdata[ii]>Xmax then Xmax := DMSegReg.Xdata[ii];
    if DMSegReg.Ydata[ii]<Ymin then Ymin := DMSegReg.Ydata[ii];
    if DMSegReg.Xdata[ii]<Xmin then Xmin := DMSegReg.Xdata[ii];
  end;

  Xmax:=Xmax+0.1*(Xmax-Xmin);
  Ymax:=Ymax+0.1*(Ymax-Ymin);
  Xmin:=Xmin-0.05*(Xmax-Xmin);
  Ymin:=Ymin-0.05*(Ymax-Ymin);

  FactorX:=1;
  InverseX:=false;
  if Xmin<0 then if abs(Xmin)>abs(Xmax) then InverseX:=true;

  if not InverseX then
  begin
    if {(Xmin>0) and }(Xmax<0.01) then
    begin
      FactorX:=1000;
      Xmin:=FactorX*Xmin;
      Xmax:=FactorX*Xmax;
    end;
    if {(Xmin>0) and} (Xmax<0.1) and (Xmax>0.01) then
    begin
      FactorX:=100;
      Xmin:=FactorX*Xmin;
      Xmax:=FactorX*Xmax;
    end;
    if {(Xmin>0) and }(Xmax<1) and (Xmax>0.1) then
    begin
      FactorX:=10;
      Xmin:=FactorX*Xmin;
      Xmax:=FactorX*Xmax;
    end;
  end; {not InverseX}

  if InverseX then
  begin
    if (Xmax<0) and (Xmin>-0.01) then
    begin
      FactorX:=1000;
      Xmin:=FactorX*Xmin;
      Xmax:=FactorX*Xmax;
    end;
    if (Xmax<0) and (Xmin>-0.1) and (Xmin<-0.01) then
    begin
      FactorX:=100;
      Xmin:=FactorX*Xmin;
      Xmax:=FactorX*Xmax;
    end;
    if (Xmax<0) and (Xmin<-1) and (Xmin>-0.1) then
    begin
      FactorX:=10;
      Xmin:=FactorX*Xmin;
      Xmax:=FactorX*Xmax;
    end;
  end; {InverseX}

  for ii:=0 to DMSegReg.NrOfData-1 do with DMSegReg do
       Xdata[ii]:=FactorX*Xdata[ii];

    if Xmax<10 then
    begin
      decimX := 1;
      MinX := round (Xmin-0.5);
      MaxX := round (Xmax+0.5);
      ScaleX := MaxX-MinX;
    end
    else if Xmax<25 then
    begin
      decimX := 1;
      MinX := 4*round ((Xmin-2)/4);
      MaxX := 4*round ((Xmax+2)/4);
      ScaleX := (MaxX-MinX) div 4;
    end
    else if Xmax<50 then
    begin
      decimX := 1;
      MinX := 5*round ((Xmin-2.5)/5);
      MaxX := 5*round ((Xmax+2.5)/5);
      ScaleX := (MaxX-MinX) div 5;
    end
    else if Xmax<100 then
    begin
      decimX := 0;
      MinX := 10*round ((Xmin-5)/10);
      MaxX := 10*round ((Xmax+5)/10);
      ScaleX := (MaxX-MinX) div 10;
    end
    else if Xmax<250 then
    begin
      decimX := 0;
      MinX := 25*round ((2*Xmin-25)/50);
      MaxX := 25*round ((2*Xmax+25)/50);
      ScaleX := (MaxX-MinX) div 25;
    end
    else if Xmax<500 then
    begin
      decimX := 0;
      MinX := 50*round ((Xmin-25)/50);
      MaxX := 50*round ((Xmax+25)/50);
      ScaleX := (MaxX-MinX) div 50;
    end
    else if Xmax<1000 then
    begin
      decimX := 0;
      MinX:=round (Xmin);
      MaxX:=round (Xmax);
      ScaleX := (MaxX-MinX) div 100;
    end
    else if Xmax<2500 then
    begin
      decimX := 0;
      MinX:=round (Xmin);
      MaxX:=round (Xmax);
      ScaleX := (MaxX-MinX) div 250;
    end
    else if Xmax<5000 then
    begin
      decimX := 0;
      MinX:=round (Xmin);
      MaxX:=round (Xmax);
      ScaleX := (MaxX-MinX) div 500;
    end
    else if Xmax<10000 then
    begin
      decimX := 0;
      MinX:=round (Xmin);
      MaxX:=round (Xmax);
      ScaleX := (MaxX-MinX) div 1000;
    end
    else if Xmax<25000 then
    begin
      decimX := 0;
      MinX:=round (Xmin)-1000;
      MaxX:=round (Xmax)+1000;
      ScaleX := (MaxX-MinX) div 2500;
    end
    else if Xmax<50000 then
    begin
      decimX := 0;
      MinX:=round (Xmin)-2500;
      MaxX:=round (Xmax)+2500;
      ScaleX := (MaxX-MinX) div 5000;
    end
    else
    begin
      decimX := 0;
      MinX:=round (Xmin)-5000;
      MaxX:=round (Xmax)+5000;
      ScaleX := (MaxX-MinX) div 10000;
    end;

  FactorY:=1;
  InverseY:=false;
  if Ymin<0 then if abs(Ymin)>abs(Ymax) then InverseY:=true;

  if not InverseY then
  begin
    if (Ymin<-0.01) and (Ymax<0.1) then
    begin
      FactorY:=10;
      Ymin:=FactorY*Ymin;
      Ymax:=FactorY*Ymax;
    end;
    if (Ymin<-0.001) and (Ymax<0.01) then
    begin
      FactorY:=100;
      Ymin:=FactorY*Ymin;
      Ymax:=FactorY*Ymax;
    end;
    if (Ymin>0) and (Ymax<0.01) then
    begin
      FactorY:=1000;
      Ymin:=FactorY*Ymin;
      Ymax:=FactorY*Ymax;
    end;
    if (Ymin>0) and (Ymax<0.1) and (Ymax>0.01) then
    begin
      FactorY:=100;
      Ymin:=FactorY*Ymin;
      Ymax:=FactorY*Ymax;
    end;
    if (Ymin>0) and (Ymax<1) and (Ymax>0.1) then
    begin
      FactorY:=10;
      Ymin:=FactorY*Ymin;
      Ymax:=FactorY*Ymax;
    end;
  end; {not InversY}

  if InverseY then
  begin
    if (Ymax<0) and (Ymin>-0.01) then
    begin
      FactorY:=1000;
      Ymin:=FactorY*Ymin;
      Ymax:=FactorY*Ymax;
    end;
    if (Ymax<0) and (Ymin>-0.1) and (Ymin<-0.01) then
    begin
      FactorY:=100;
      Ymin:=FactorY*Ymin;
      Ymax:=FactorY*Ymax;
    end;
    if (Ymax<0) and (Ymin>-1) and (Ymin<-0.1) then
    begin
      FactorY:=10;
      Ymin:=FactorY*Ymin;
      Ymax:=FactorY*Ymax;
    end;
  end; {InverseY}

  for ii:=0 to DMSegReg.NrOfData-1 do with DMSegReg do
      Ydata[ii]:=FactorY*Ydata[ii];

    if Ymax<10 then
    begin
      decimY := 1;
      MinY := round (Ymin-0.5);
      MaxY := round (Ymax+0.5);
      ScaleY := MaxY-MinY;
      if ScaleY>10 then ScaleY := (MaxY-MinY) div 2;
    end
    else if Ymax<25 then
    begin
      decimY := 1;
      MinY := 4*round ((Ymin-2)/4);
      MaxY := 4*round ((Ymax+2)/4);
      ScaleY := (MaxY-MinY) div 4;
    end
    else if Ymax<50 then
    begin
      decimY := 1;
      MinY := 5*round ((Ymin-2.5)/5);
      MaxY := 5*round ((Ymax+2.5)/5);
      ScaleY := (MaxY-MinY) div 5;
    end
    else if Ymax<100 then
    begin
      decimY := 0;
      MinY := 10*round ((Ymin-5)/10);
      MaxY := 10*round ((Ymax+5)/10);
      ScaleY := (MaxY-MinY) div 10;
    end
    else if Ymax<250 then
    begin
      decimY := 0;
      MinY := 25*round ((Ymin-12.5)/25);
      MaxY := 25*round ((Ymax+12.5)/25);
      ScaleY := (MaxY-MinY) div 25;
    end
    else if Ymax<500 then
    begin
      decimY := 0;
      MinY := 50*round ((Ymin-25)/50);
      MaxY := 50*round ((Ymax+25)/50);
      ScaleY := (MaxY-MinY) div 50;
    end
    else if Ymax<1000 then
    begin
      decimY := 0;
      MinY:=round (Ymin);
      MaxY:=round (Ymax);
      ScaleY := (MaxY-MinY) div 100;
    end
    else if Ymax<2500 then
    begin
      decimY := 0;
      MinY:=round (Ymin);
      MaxY:=round (Ymax);
      ScaleY := (MaxY-MinY) div 250;
    end
    else if Ymax<5000 then
    begin
      decimY := 0;
      MinY:=round (Ymin);
      MaxY:=round (Ymax);
      ScaleY := (MaxY-MinY) div 500;
    end
    else if Ymax<10000 then
    begin
      decimY := 0;
      MinY:=round (Ymin);
      MaxY:=round (Ymax);
      ScaleY := (MaxY-MinY) div 1000;
    end
    else if Ymax<25000 then
    begin
      decimY := 0;
      MinY:=round (Ymin);
      MaxY:=round (Ymax);
      ScaleY := (MaxY-MinY) div 2500;
    end
    else if Ymax<50000 then
    begin
      decimY := 0;
      MinY:=round (Ymin);
      MaxY:=round (Ymax);
      ScaleY := (MaxY-MinY) div 5000;
    end
    else
    begin
      decimY := 0;
      MinY:=round (Ymin);
      MaxY:=round (Ymax);
      ScaleY := (MaxY-MinY) div 10000;
    end;

  if ScaleX>10 then
  begin
    ScaleX:=10;
    DecimX:=DecimX+1;
  end;
  if (ScaleY>10) then
  begin
    ScaleY:=10;
    DecimY:=DecimY+1;
  end;
  if ScaleX<4 then
  begin
    ScaleX:=4;
    if MaxX<100 then DecimX:=DecimX+1;
  end;
  if ScaleY<4 then
  begin
    ScaleY:=4;
    if MaxY<100 then DecimY:=DecimY+1;
  end;

end;
{end of MaxMin}
{-------------}



{Relative is part of Graphics}
{----------------------------}
procedure Relative;
var  ii : integer;
     XdataRel,YdataRel,ZdataRel : real;
begin

  with DMSegReg do for ii:=0 to NrOfData-1 do
  begin
    XdataRel := LX*(DMSegReg.Xdata[ii]-MinX)/(MaxX-MinX);
    SetLength (RelXdata,ii+1);
    RelXdata[ii] := PosX1+round(XdataRel);
    YdataRel := LY*(DMSegReg.Ydata[ii]-MinY)/(MaxY-MinY);
    SetLength (RelYdata,ii+1);
    RelYdata[ii] := PosY2-round(YdataRel)-10;
    ZdataRel := LY*(DMSegReg.Zdata[ii]-MinY)/(MaxY-MinY);
    SetLength (RelZdata,ii+1);
    RelZdata[ii] := PosY2-round(ZdataRel)-10;
  end;

end;
{---------------}
{end of Relative}



{Legends is part of TSegRegForm.ShowGraphics1 & 2}
{------------------------------------------------}
procedure Legends;
begin

  LegendX:='X-Data';
  if FactorX=10 then LegendX:='X-data * 10';
  if FactorX=100 then LegendX:='X-data * 100';
  if DMSegReg.Mark=' BPz' then
  begin
    LegendX:='Z-Data';
    if FactorX=10 then LegendX:='Z-data * 10';
    if FactorX=100 then LegendX:='Z-data * 100';
  end;
//Above X-legends are for GraphIndex 10,11,16,17,20,22
  if (GraphIndex in [12,13,14,15,19,21]) or (DMSegReg.Option=2) then
  begin
    LegendX:='Z-Data';
    if FactorX=10 then LegendX:='Z-data * 10';
    if FactorX=100 then LegendX:='Z-data * 100';
  end;
  if (GraphIndex in [16,17]) or (DMSegReg.Option=1) then
  begin
    LegendX:='X-Data';
    if FactorX=10 then LegendX:='X-data * 10';
    if FactorX=100 then LegendX:='X-data * 100';
  end;

  LegendY:='Y-Data';
  if FactorY=10 then LegendY:='Y-data * 10';
  if FactorY=100 then LegendX:='Y-data * 100';
//Above Y-legends for GraphIndex 10,11,12,13,19,20

  if GraphIndex in [14,15] then
  begin
    LegendY:='YXr residuals';
    if FactorY=10 then LegendY:='YXr residuals * 10';
    if FactorY=100 then LegendY:='YXr residuals * 100';
  end;

  if GraphIndex in [16,17] then
  begin
    LegendY:='YZr residuals';
    if FactorY=10 then LegendY:='YZr residuals * 10';
    if FactorY=100 then LegendY:='YZr residuals * 100';
  end;

  if GraphIndex=18 then
  begin
    LegendX := 'Ycalc';
    if FactorX=10 then LegendX := 'Ycalc * 10';
    if FactorX=100 then LegendX := 'Ycalc * 100';
    LegendY := 'Yobs';
    if FactorY=10 then LegendY := 'Yobs * 10';
    if FactorY=100 then LegendY := 'Yobs * 100';
  end;

  if GraphIndex=20 then
  begin
    LegendX := 'X-Data';
    if FactorX=10 then LegendX := 'X-data * 10';
    if FactorX=100 then LegendX := 'X-data * 100';
  end;

  if GraphIndex=21 then
  begin
    LegendY := 'X-Data';
    if FactorX=10 then LegendY := 'X-data * 10';
    if FactorX=100 then LegendY := 'X-data * 100';
  end;

  if GraphIndex=22 then
  begin
    LegendX:='X-Data';
    if FactorX=10 then LegendX:='X-data * 10';
    if FactorX=100 then LegendX:='X-data * 100';
    LegendY := 'Z-Data';
    if FactorX=10 then LegendY := 'Z-data * 10';
    if FactorX=100 then LegendY := 'Z-data * 100';
  end;

end;
{end of Legends}
{--------------}



{Parameters1 is part of TSegRegForm.ShowGraphics1, RegrType 0, 1 : BP=0}
{----------------------------------------------------------------------}
procedure Parameters1;

var
  StdYRt,StdYa : real;
  Agr, Akl : real;

begin

  if GraphIndex<18 then                            {line plot parameters}
  begin

    AAs:=FactorY*AAs/FactorX;
    StdA1:=FactorY*StdA1/FactorX;
    StdA2:=FactorY*StdA2/FactorX;
    AvY:=FactorY*AvY1;
    StdY1:=FactorY*StdY1;                        {st.dev.Y residuals}
    AvX:=FactorX*AvX1;
    if RegrType=0 then
    begin
      X1 := Xmin;
      X2 := Xmax;
      Y1 := AvY;
      Y2 := AvY;
      A1 := AAs;
    end;

    if (RegrType>0) and (GraphIndex<18) then
    begin
      A1 := AAs;
      Y1 := A1*(Xmin-AvX) + AvY;
      Y2 := A1*(Xmax-AvX) + AvY;
      X1 := Xmin;
      X2 := Xmax;
      if (Y1>Ymax) and (A1<>0) then
      begin
        Y1 := Ymax;
        X1 := AvX + (Ymax-AvY)/A1;
      end;
      if (Y2>Ymax) and (A1<>0) then
      begin
        Y2 := Ymax;
        X2 := AvX + (Ymax-AvY)/A1;
      end;
      if (Y1<Ymin) and (A1<>0) then
      begin
        Y1 := Ymin;
        X1 := AvX + (Ymin-AvY)/A1;
      end;
      if (Y2<Ymin) and (A1<>0) then
      begin
        Y2 := Ymin;
        X2 := AvX + (Ymin-AvY)/A1;
      end;
    end;

  end;                                      {end of line plot parameter}

  if GraphIndex<18 then
  begin                          {parameters conf.belt around straight line}

    Agr   := A1+1.75*StdA1;
    Akl   := A1-1.75*StdA1;
    StdYRt := 1.4*StdY1/sqrt(DMSegReg.NrOfData);
    StdYa := StdY1/sqrt(DMSegReg.NrOfData);
    X3  := Xmin;
    Y3  := Akl*(Xmin-AvX)+AvY;
    if Y3>Ymax then
    begin
      Y3 := Ymax;
      X3 := (Ymax-AvY)/Akl+AvX;
    end;
    if abs(Akl-A1)>0 then X4 := AvX+1.75*StdYRt/(Akl-A1)
       else X4:=AvX;
    Y4 := Akl*(X4-AvX)+AvY;
    if X4<Xmin then
    begin
      X4:=X3;
      Y4:=Y3;
    end;
    if abs(Agr-A1)>0 then X5 := AvX+1.75*StdYRt/(Agr-A1)
       else X5:=AvX;
    Y5 := Agr*(X5-AvX)+AvY;
    X6 := Xmax;
    Y6 := Agr*(Xmax-AvX)+AvY;
    if Y6>Ymax then
    begin
      Y6 := Ymax;
      X6 := (Ymax-AvY)/Agr+AvX;
    end;
    if X5>Xmax then
    begin
      X5:=X6;
      Y5:=Y6;
    end;
    X7 := Xmin;
    Y7 := Agr*(Xmin-AvX)+AvY;
    if Y7<Ymin then
    begin
      Y7 := Ymin;
      X7 := (Ymin-AvY)/Agr+AvX;
    end;
    if abs(Agr-A1)>0 then X8 := AvX-1.75*StdYRt/(Agr-A1)
       else X8:=AvX;
    Y8 := Agr*(X8-AvX)+AvY;
    if X8<Xmin then
    begin
      X8:=X7;
      Y8:=Y7;
    end;
    if abs(Akl-A1)>0 then X9 := AvX-1.75*StdYRt/(Akl-A1)
       else X9:=AvX;
    Y9 := Akl*(X9-AvX)+AvY;
    if X9<AvX then
    begin
      X9:=AvX;
      Y9:=AvY-1.75*StdYRt;
    end;
    X10 := Xmax;
    Y10 := Akl*(Xmax-AvX)+AvY;
    if Y10<Ymin then
    begin
      Y10 := Ymin;
      X10 := (Ymin-AvY)/Akl+AvX;
    end;
    if X9>Xmax then
    begin
      X9:=X8;
      Y9:=Y8;
    end;

    X11:=AvX-0.2*(Xmax-Xmin);
    if X11<X4 then X11:=0.5*(AvX+X4);
    Y11:=A1*(X11-AvX)+AvY+1.75*StdYa;
    X12:=AvX+0.2*(Xmax-Xmin);
    if X12>X5 then X12:=0.5*(AvX+X5);
    Y12:=A1*(X12-AvX)+AvY+1.75*StdYa;
    X13:=X11;
    if X13<X8 then X13:=0.5*(AvX++X8);
    Y13:=A1*(X13-AvX)+AvY-1.75*StdYa;
    X14:=X12;
    if X14>X9 then X14:=0.5*(AvX+X9);
    Y14:=A1*(X14-AvX)+AvY-1.75*StdYa;

  end;
                          {end of parameters conf.belt around straight line}

  if GraphIndex=18 then with DMSegReg do
  begin                              {parameters calc/obs straight line}
    X1 := Xmin;
    Y1 := FactorY*X1/FactorX;
    if Y1<Ymin then
    begin
      Y1:=Ymin;
      X1:=Y1*FactorX/FactorY;
    end;
    X2 := Xmax;
    Y2 := FactorY*Xmax/FactorX;
    if Y2>Ymax then
    begin
      Y2:=Ymax;
      X2:=FactorX*Y2/FactorY;
    end;
 end;
                                   {end of parameters calc/obs straight line}
end;  {end of Parameters1}
{------------------------}

{Parameters2 is part of TSegRegForm.ShowGraphics2, BP>0, RegrType 2, 3, 4}
{------------------------------------------------------------------------}
procedure Parameters2;

var
  StdYRtSq, StdAtSq, SumYdevSq, SumXdevSq : real;

begin

  BP := FactorX*BP1;
  AAs:=FactorY*AAs/FactorX;
  Ag:=FactorY*Ag/FactorX;
  AvY1:=FactorY*AvY1;
  AvY2:=FactorY*AvY2;
  AvX1:=FactorX*AvX1;
  AvX2:=FactorX*AvX2;
  YatBP:=FactorY*YatBP;
  if GraphIndex in [14,15,16,17] then
  begin
    BP := FactorX*BP2;
    RegrType := RegrType2;
  end;
                                            {parameters relation RegrType 2,3,4}
    if RegrType=3 then
       if (RegrMeth1=1) or (RegrMeth2=1) then AvY1:=Ag*(BP-AvX2)+AvY2
       else Ag:=(AvY2-AvY1)/(AvX2-BP);
    if RegrType=4 then
       if (RegrMeth1=1) or (RegrMeth2=1) then  AvY2:=AAs*(BP-AvX1)+AvY1
       else AAs:=(AvY2-AvY1)/(BP-AvX1);
//The Ag and AAs definitions hereunder for type 2 by Regr. Method are not
//strictly necessary, zie ook UDMSegReg, ReadOutputData
     if RegrType=2 then
        if (RegrMeth1=1) or (RegrMeth2=1) then Ag := (YatBP-AvY2)/(BP-AvX2)
        else AAs := (YatBP-AvY1)/(BP-AvX1);;

    X1:=Xmin;
    Y1 := AAs*(Xmin-AvX1)+AvY1;
    X2 := BP;
    Y2 := AAs*(BP-AvX1)+AvY1;
    X3 := Xmax;
    Y3 := Ag*(Xmax-AvX2)+AvY2;
    if (Y1>Ymax) and (AAs<>0) then
    begin
      Y1:=Ymax;
      X1:=(Ymax-AvY1)/AAs+AvX1;
    end;
    if (Y1<Ymin) and (AAs<>0) then
    begin
      Y1:=Ymin;
      X1:=(Ymin-AvY1)/AAs+AvX1;
    end;
    if (Y3>Ymax) and (Ag<>0) then
    begin
      Y3:=Ymax;
      X3:=(Ymax-AvY2)/Ag+AvX2;
    end;
    if (Y3<Ymin) and (Ag<>0) then
    begin
      Y3:=Ymin;
      X3:=(Ymin-AvY2)/Ag+AvX2;
    end;

                                           { start conf. belt RegrType 2, 3, 4}
  AvXall:=FactorX*AvXall;     {AvXall is defined in USegRegForm, GoButtonclick}
  Aux1 := (Nr1-1)*sqr(FactorY*StDevY1);               {Sum Sq of reduced Y <BP}
  Aux2 := (Nr1-1)*sqr(FactorY*StDevY2);               {Sum Sq of reduced Y >BP}
  SumYdevSq := (1-ExplCoeff)*(Aux1+Aux2);
  StdYRtSq := SumYdevSq/((Nr1+Nr2)*(Nr1+Nr2-2));
  SumXdevSq := (Nr1+Nr2-1)*sqr(FactorX*StDevX); {Sum Sq of reduced X, all data}
  StdAtSq:= SumYdevSq/((Nr1+Nr2-1)*SumXdevSq);

  X5 := Xmin;
  if StdYRtSq+sqr(X5-AvXall)*StdAtSq > 0 then
     Aux3 := FactorY*sqrt(StdYRtSq+sqr(X5-AvXall)*StdAtSq)
  else Aux3:=0;
  Y5 := AAs*(Xmin-AvX1) + AvY1 + 1.75*Aux3;
  X6 := AvX1;
  if StdYRtSq+sqr(X6-AvXall)*StdAtSq > 0 then
     Aux4 := FactorY*sqrt(StdYRtSq+sqr(X6-AvXall)*StdAtSq)
  else Aux4:=0;
  Y6 := AvY1 + 1.75*Aux4;
  if Y5>Ymax then
  begin
    if AAs<>0 then
    begin
      Y5 := Ymax;
      X5 := (Y5-AvY1-1.75*Aux3)/AAs + AvX1;
    end else
    begin
      Y5:=Y6;
      X5:=X6;
    end;
  end;
  if Y5<Ymin then
  begin
    if AAs<>0 then
    begin
      Y5 := Ymin;
      X5 := (Y5-AvY1-1.75*Aux3)/AAs + AvX1;
    end else
    begin
      Y5:=Y6;
      X5:=X6;
    end;
  end;

  if (X6<X5) or (Y6>Ymax) or (Y6<Ymin) then
  begin
    X6:=X5;
    Y6:=Y5;
  end;

  if AvXall>BP then
  begin
    X13 := BP;
    if StdYRtSq+sqr(X13-AvXall)*StdAtSq > 0 then
       Aux3 := FactorY*sqrt(StdYRtSq+sqr(X13-AvXall)*StdAtSq)
    else Aux3:=0;
    Y13 := AAs*(X13-AvX1) + AvY1 + 1.75*Aux3;
    X14 := AvXall;
    if StdYRtSq+sqr(X14-AvXall)*StdAtSq > 0 then
       Aux4 := FactorY*sqrt(StdYRtSq+sqr(X14-AvXall)*StdAtSq)
    else Aux4:=0;
    Y14 := Ag*(X14-AvX2) + AvY2 + 1.75*Aux4;
  end else
  begin
    X13 := AvXall;
    if StdYRtSq+sqr(X13-AvXall)*StdAtSq > 0 then
       Aux3 := FactorY*sqrt(StdYRtSq+sqr(X13-AvXall)*StdAtSq)
    else Aux3:=0;
    Y13 := AAs*(X13-AvX1) + AvY1 + 1.75*Aux3;
    X14 := BP;
    if StdYRtSq+sqr(X14-AvXall)*StdAtSq > 0 then
       Aux4 := FactorY*sqrt(StdYRtSq+sqr(X14-AvXall)*StdAtSq)
    else Aux4:=0;
    Y14 := AAs*(X14-AvX1) + AvY1 + 1.75*Aux4;
  end;

  X7 := AvX2;
  if StdYRtSq+sqr(X7-AvXall)*StdAtSq > 0 then
     Aux3 := FactorY*sqrt(StdYRtSq+sqr(X7-AvXall)*StdAtSq)
  else Aux3:=0;
  Y7 := Ag*(X7-AvX2) + AvY2;
  Y7 := Ag*(X7-AvX2) + AvY2 + 1.75*Aux3;
  X8 := Xmax;
  if StdYRtSq+sqr(X8-AvXall)*StdAtSq > 0 then
     Aux4 := FactorY*sqrt(StdYRtSq+sqr(X8-AvXall)*StdAtSq)
  else Aux4:=0;
  Y8 := Ag*(X8-AvX2) + AvY2 + 1.75*Aux4;
  if Y8>1.05*Ymax then
  begin
    if Ag<>0 then
    begin
      Y8 := Ymax;
      X8 := (Y8-AvY2-1.75*Aux4)/Ag + AvX2;
    end else
    begin
      Y8:=Y7;
      X8:=X7;
    end;
  end;
  if Y8<Ymin then
  begin
    if Ag<>0 then
    begin
      Y8 := Ymin;
      X8 := (Y8-AvY2-1.75*Aux4)/Ag + AvX2;
    end else
    begin
      Y8:=Y7;
      X8:=X7;
    end;
  end;
  if (X7>X8) or (Y7>Ymax) or (Y7<Ymin) then
  begin
    X7:=X8;
    Y7:=Y8;
  end;
  if (X7>X8) or (Y7>Ymax) or (Y7<Ymin) then
  begin
    X7:=X8;
    Y7:=Y8;
  end;

  X9 := Xmin;
  if StdYRtSq+sqr(X9-AvXall)*StdAtSq  > 0 then
     Aux3 := FactorY*sqrt(StdYRtSq+sqr(X9-AvXall)*StdAtSq)
  else Aux3:=0;
  Y9 := AAs*(X9-AvX1) + AvY1 - 1.75*Aux3;
  X10 := AvX1;
  if StdYRtSq+sqr(X10-AvXall)*StdAtSq > 0 then
     Aux4 := FactorY*sqrt(StdYRtSq+sqr(X10-AvXall)*StdAtSq)
  else Aux4:=0;
  Y10 := AAs*(X10-AvX1) + AvY1 - 1.75*Aux4;
  if Y9<Ymin then
  begin
    if AAs<>0 then
    begin
      Y9 := Ymin;
      X9 := (Y9-AvY1+1.75*Aux3)/AAs + AvX1;
    end else
    begin
      Y9:=Y10;
      X9:=X10;
    end;
  end;
  if Y9>Ymax then
  begin
    if AAs<>0 then
    begin
      Y9 := Ymax;
      X9 := (Y9-AvY1+1.75*Aux3)/AAs + AvX1;
    end else
    begin
      Y9:=Y10;
      X9:=X10;
    end;
  end;
  if (X10<X9) or (Y10>Ymax) or (Y10<Ymin) then
  begin
    X10:=X9;
    Y10:=Y9;
  end;

  if AvXall>BP then
  begin
    X15 := BP;
    if StdYRtSq+sqr(X15-AvXall)*StdAtSq > 0 then
      Aux3 := FactorY*sqrt(StdYRtSq+sqr(X15-AvXall)*StdAtSq)
    else Aux3:=0;
    Y15 := AAs*(X15-AvX1) + AvY1 - 1.75*Aux3;
    X16 := AvXall;
    if StdYRtSq+sqr(X16-AvXall)*StdAtSq > 0 then
       Aux4 := FactorY*sqrt(StdYRtSq+sqr(X16-AvXall)*StdAtSq)
    else Aux4:=0;
    Y16 := Ag*(X16-AvX2) + AvY2 - 1.75*Aux4;
  end else
  begin
    X15 := AvXall;
    if StdYRtSq+sqr(X15-AvXall)*StdAtSq >0 then
       Aux3 := FactorY*sqrt(StdYRtSq+sqr(X15-AvXall)*StdAtSq)
    else Aux3:=0;
    Y15 := AAs*(X15-AvX1) + AvY1 - 1.75*Aux3;
    X16 := BP;
    if StdYRtSq+sqr(X16-AvXall)*StdAtSq > 0 then
       Aux4 := FactorY*sqrt(StdYRtSq+sqr(X16-AvXall)*StdAtSq)
    else Aux4:=0;
    Y16 := AAs*(X16-AvX1) + AvY1 - 1.75*Aux4;
  end;

  X11 := AvX2;
  if StdYRtSq+sqr(X11-AvXall)*StdAtSq > 0 then
     Aux3 := FactorY*sqrt(StdYRtSq+sqr(X11-AvXall)*StdAtSq)
  else Aux3:=0;
  Y11 := Ag*(X11-AvX2) + AvY2 - 1.75*Aux3;
  X12 := Xmax;
  if StdYRtSq+sqr(X12-AvXall)*StdAtSq > 0 then
     Aux4 := FactorY*sqrt(StdYRtSq+sqr(X12-AvXall)*StdAtSq)
  else Aux4:=0;
  Y12 := Ag*(X12-AvX2) + AvY2 - 1.75*Aux4;
  if Y12>Ymax then
  begin
    if Ag<>0 then
    begin
      Y12 := Ymax;
      X12 := (Y12-AvY2+1.75*Aux4)/Ag + AvX2;
    end else
    begin
      Y12:=Y11;
      X12:=X11;
    end;
  end;
  if Y12<Ymin then
  begin
    if Ag<>0 then
    begin
      Y12 := Ymin;
      X12 := (Y12-AvY2+1.75*Aux4)/Ag + AvX2;
    end else
    begin
      Y12:=Y11;
      X12:=X11;
    end;
  end;
  if (X11>X12) or (Y11>Ymax) or (Y11<Ymin) then
  begin
    X11:=X12;
    Y11:=Y12;
  end;
                                               { conf. block BP RegrType 2,3,4}
  if (RegrType=3) or (RegrType=4) or (RegrType=2) then
  begin
    if RegrType=3 then X17 := BP-2*FactorX*SDbp;
    if RegrType=4 then X17 := BP-1.75*FactorX*SDbp;
    if X17<Xmin then X17 := Xmin;
    if RegrType=3 then X18 := BP+1.75*FactorX*SDbp;
    if RegrType=4 then X18 := BP+2*FactorX*SDbp;
    if RegrType=2 then X17 := BP-1.8*FactorX*SDbp;
    if RegrType=2 then X18 := BP+1.8*FactorX*SDbp;
    if X17<Xmin then X17 := Xmin;
    if X18>Xmax then X18 := Xmax;
    if StdYRtSq+sqr(BP-AvXall)*StdAtSq > 0 then
       Aux3 := FactorY*sqrt(StdYRtSq+sqr(BP-AvXall)*StdAtSq)
    else Aux3:=0;
    PlotY1 := AAs*(BP-AvX1) + AvY1 - 1.75*Aux3;
    PlotY2 := AAs*(BP-AvX1) + AvY1 + 1.75*Aux3;
  end;                                   { end conf. block BP RegrType 2,3,4}
end;  {end of Parameters2}
{------------------------}


{Parameters3 is part of TSegRegForm.ShowGraphics2, BP>0, RegrType 5,6}
{--------------------------------------------------------------------}
procedure Parameters3;

var
  StdYRtSq, StdAtSq  : real;

begin

  BP := FactorX*BP1;
  RegrType := RegrType1;
  AAs:=FactorY*AAs/FactorX;
  Ag:=FactorY*Ag/FactorX;
  AvY1:=FactorY*AvY1;
  AvY2:=FactorY*AvY2;
  AvX1:=FactorX*AvX1;
  AvX2:=FactorX*AvX2;
  if (GraphIndex=14) or (GraphIndex=16) then
  begin
    BP := FactorX*BP2;
    RegrType := RegrType2;
  end;
                                             {parameters relation RegrType 5,6}
  if RegrType=5 then
  begin
    X1 := Xmin;
    Y1 := AvY1;
    X2 := BP;
    Y2 := AvY1;
    X3 := BP;
    Y3 := AvY2;
    X4 := Xmax;
    Y4 := AvY2;
  end;

  if RegrType>5 then
  begin

    X1 := Xmin;
    Y1 := AAs*(Xmin-AvX1)+AvY1;

    if (Y1<Ymin) and (AAs<>0) then
    begin
      Y1:=Ymin;
      X1:=(Ymin-AvY1)/AAs+AvX1;
    end;
    if (Y1>Ymax) and (AAs<>0) then
    begin
      Y1:=Ymax;
      X1:=(Ymax-AvY1)/AAs+AvX1;
    end;

    X2 := BP;
    Y2 := AAs*(BP-AvX1)+AvY1;

    if (Y2<Ymin) and (AAs<>0) then
    begin
      Y2:=Ymin;
      X2:=(Ymin-AvY1)/AAs+AvX1;
    end;
    if (Y2>Ymax) and (AAs<>0) then
    begin
      Y2:=Ymax;
      X2:=(Ymax-AvY1)/AAs+AvX1;
    end;

    X3 := BP;
    Y3 := Ag*(BP-AvX2)+AvY2;

    if (Y3<Ymin) and (Ag<>0) then
    begin
      Y3:=Ymin;
      X3:=(Ymin-AvY2)/Ag+AvX2;
    end;
    if (Y3>Ymax) and (Ag<>0) then
    begin
      Y3:=Ymax;
      X3:=(Ymax-AvY2)/Ag+AvX2;
    end;

    X4 := Xmax;
    Y4 := Ag*(Xmax-AvX2)+AvY2;

    if (Y4<Ymin) and (Ag<>0) then
    begin
      Y4:=Ymin;
      X4:=(Ymin-AvY2)/Ag+AvX2;
    end;
    if (Y4>Ymax) and (Ag<>0) then
    begin
      Y4 := Ymax;
      X4 := (Ymax-AvY2)/Ag+AvX2;
    end;

    A1:=AAs;
    A2:=Ag;

  end;
                                           {parameters conf. belt RegrType 5,6}
  AvXall:=FactorX*AvXall;
  Aux1 := (Nr1-2)*StdY1*StdY1;                    {RedSumSq of Ydeviations <BP}
  Aux2 := (Nr2-2)*StdY2*StdY2;                    {RedSumSq of Ydeviations >BP}
  RedSumXsq1:=Nr1*sqr(FactorX*StDevX);
  StdAtSq := (Aux1+Aux2)/(RedSumXsq1*(Nr1+Nr2-2));
  StdYRtSq := (Aux1+Aux2)/((Nr1+Nr2)*(Nr1+Nr2-2));

  X5 := X1;
  Aux3 := FactorY*sqrt(StdYRtSq+sqr(X5-AvXall)*StdAtSq);
  Y5 := Y1 + 1.75*Aux3;
  X6 := AvX1;
  Aux4 := FactorY*sqrt(StdYRtSq+sqr(X6-AvXall)*StdAtSq);
  Y6 := AAs*(X6-AvX1) + AvY1 + 1.75*Aux4;
  if Y6<Ymin then
  begin
    X6 := X6+0.5*(X6-X5);
    Aux4 := FactorY*sqrt(StdYRtSq+sqr(X6-AvXall)*StdAtSq);
    Y6 := AAs*(X6-AvX1) + AvY1 + 1.75*Aux4;
  end;
  if Y6>Ymax then
  begin
    X6 := X6-0.5*(X6-X5);
    Aux4 := FactorY*sqrt(StdYRtSq+sqr(X6-AvXall)*StdAtSq);
    Y6 := AAs*(X6-AvX1) + AvY1 + 1.75*Aux4;
  end;
  if (X6<X5) or (Y6>Ymax) or (Y6<Ymin) then
  begin
    X6:=X5;
    Y6:=Y5;
  end;

  X13 := X2;
  Aux3 := FactorY*sqrt(StdYRtSq+sqr(X13-AvXall)*StdAtSq);
  Y13 := Y2 + 1.75*Aux3;
  X13A := X3;
  Aux4 := FactorY*sqrt(StdYRtSq+sqr(X13A-AvXall)*StdAtSq);
  Y13A := Y3 + 1.75*Aux4;
  X7 := AvX2;
  Aux3 := FactorY*sqrt(StdYRtSq+sqr(X7-AvXall)*StdAtSq);
  Y7 := Ag*(X7-AvX2) + AvY2 + 1.75*Aux3;
  X8 := X4;
  Aux4 := FactorY*sqrt(StdYRtSq+sqr(X8-AvXall)*StdAtSq);
  Y8 := Y4  + 1.75*Aux4;
  if Y7<Ymin then
  begin
    X7 := X7-0.5*(X8-X7);
    Aux3 := FactorY*sqrt(StdYRtSq+sqr(X7-AvXall)*StdAtSq);
    Y7 := Ag*(X7-AvX2) + AvY2 + 1.75*Aux3;
  end;
  if Y7>Ymax then
  begin
    X7 := X7-0.5*(X8-X7);
    Aux3 := FactorY*sqrt(StdYRtSq+sqr(X7-AvXall)*StdAtSq);
    Y7 := Ag*(X7-AvX2) + AvY2 + 1.75*Aux3;
  end;
  if (X7>X8) or (Y7>Ymax) or (Y7<Ymin) then
  begin
    X7:=X8;
    Y7:=Y8;
  end;
  if (X7>X8) or (Y7>Ymax) or (Y7<Ymin) then
  begin
    X7:=X8;
    Y7:=Y8;
  end;

  X9 := X1;
  Aux3 := FactorY*sqrt(StdYRtSq+sqr(X9-AvXall)*StdAtSq);
  Y9 := Y1 - 1.75*Aux3;
  X10 := AvX1;
  Aux4 := FactorY*sqrt(StdYRtSq+sqr(X10-AvXall)*StdAtSq);
  Y10 := AAs*(X10-AvX1) + AvY1 - 1.75*Aux4;
  if Y10<Ymin then
  begin
    X10 := X10+0.5*(X10-X9);
    Aux4 := FactorY*sqrt(StdYRtSq+sqr(X10-AvXall)*StdAtSq);
    Y10 := AAs*(X10-AvX1) + AvY1 - 1.75*Aux4;
  end;
  if Y10>Ymax then
  begin
    X10 := X10-0.5*(X10-X9);
    Aux4 := FactorY*sqrt(StdYRtSq+sqr(X10-AvXall)*StdAtSq);
    Y10 := AAs*(X10-AvX1) + AvY1 - 1.75*Aux4;
  end;
  if (X10<X9) or (Y10>Ymax) or (Y10<Ymin) then
  begin
    X10:=X9;
    Y10:=Y9;
  end;

  X15 := X2;
  Aux3 := FactorY*sqrt(StdYRtSq+sqr(X15-AvXall)*StdAtSq);
  Y15 := Y2 - 1.75*Aux3;
  X15A := X3;
  Aux4 := FactorY*sqrt(StdYRtSq+sqr(X15A-AvXall)*StdAtSq);
  Y15A := Y3 - 1.75*Aux4;

  X11 := AvX2;
  Aux3 := FactorY*sqrt(StdYRtSq+sqr(X11-AvXall)*StdAtSq);
  Y11 := Ag*(X11-AvX2) + AvY2 - 1.75*Aux3;
  X12 := X4;
  Aux4 := FactorY*sqrt(StdYRtSq+sqr(X12-AvXall)*StdAtSq);
  Y12 := Y4  - 1.75*Aux4;
  if Y11>Ymax then
  begin
    X11 := X11-0.5*(X12-X11);
    Aux3 := FactorY*sqrt(StdYRtSq+sqr(X11-AvXall)*StdAtSq);
    Y11 := Ag*(X11-AvX2) + AvY2 - 1.75*Aux3;
  end;
  if Y11<Ymin then
  begin
    X11 := X11-0.5*(X12-X11);
    Aux3 := FactorY*sqrt(StdYRtSq+sqr(X11-AvXall)*StdAtSq);
    Y11 := Ag*(X11-AvX2) + AvY2 - 1.75*Aux3;
  end;
  if (X11>X12) or (Y11>Ymax) or (Y11<Ymin) then
  begin
    X11:=X12;
    Y11:=Y12;
  end;
                                      {end of conf. belt RegrType 5,6}
end;  {end of Parameters3}
{------------------------}



{SwapVar is part of Graphics}
{---------------------------}
procedure SwapVar;

begin

  Nr1:=Nr1R;
  AvY1:=AvYr1;
  AvX1:=AvXr1;
  StdA1:=StdB1;
  StdY1:=StdYr1;
  RedSumXsq1:=RedSumXsq2;
  if (RegrType<2) then A1:=Bg;
  if (RegrType>1) then
  begin
    Nr2:=Nr2R;
    AvY2:=AvYr2;
    AvX2:=AvXr2;
    AAs:=Bs;
    Ag:=Bg;
    StdA2:=StdB2;
    StdY2:=StdYr2;
    SDbp:=SDbpR;
    AvXall1:=AvXall2;
    AvXall:=AvXallR;
    ExplCoeff:=ExplCoeffR;
    StDevY1:=StDevY1R;
    StDevY2:=StDevY2R;
    StDevX:=StDevXR;
    YatBP:=YatBPR;
  end;

end;  { end of SwapVar }
{----------------------}


end.


